<?

/**********************************************
 smartletter
 **********************************************
 version	0.1
 author		andreas franke
 email		andreas@derandi.de
 **********************************************
 this little newsletter script recieves email
 from a given via POP3 mailbox and gives you 
 the possibility to send it to a list of 
 recievers. in contrast to most newsletter 
 scripts you don't have to compose your email 
 inside a browser which is very complicated for 
 complex mails. just compose your email whith 
 your email client (e.g. outlook) and send it to
 your newsletter mailbox.
 **********************************************/
 
//all modifications are done in this file
require("settings.inc.php");
 

//don't change anything below except you know what you're doing

//just a function to extract text which begins on the specified
//keyword and ends at the end of the line
function find_extractline($search,$text)
{
	$pos = strpos(strtoupper($text),strtoupper($search));
	if ($pos <> FALSE)
	{
		$text = substr($text,$pos);
		$pos = strpos($text,"\n");
		if ($pos <> FALSE)
		{
			return substr($text,0,$pos);
		}
		else return $text;
	}
	else return "";
}

//the main class
class smartletter
{
	var $connected;
	var $mbox;
	var $server;
	var $username;
	var $hostname;
	var $overview;
	var $from;
	var $header;
	var $body;
	
	//set variables
	function smartletter()
	{
		global $server, $username, $password, $from;
		$this->connected = FALSE;
		$this->mbox = FALSE;
		$this->server = $server;
		$this->username = $username;
		$this->password = $password;
		$this->overview = array();
		$this->from = $from;
		$this->header = FALSE;
		$this->body = FALSE;
	}

	//connect to mailbox
	function connect()
	{
		$this->mbox = imap_open ("{".$this->server.":110/pop3}INBOX", $this->username, $this->password);
		if (!$this->mbox)
		{
			$this->connected = FALSE;
			return FALSE;
		}
		else 
		{
			$this->connected = TRUE;
			return TRUE;
		}
	}
	
	//guess! ;-)
	function disconnect()
	{
		if ($this->connected) imap_close($this->mbox);
	}

	//get header information and store it in an array of objects
	//see imap_fetch_overview help for more information about the
	//object structure or ask me
	function email_overview()
	{
		if (!$this->connected) $this->connect();
		if ($this->connected)
		{
			$buf=imap_check($this->mbox);
			$count=$buf->Nmsgs;
			$overview=imap_fetch_overview($this->mbox,"1:$count",0);
			if(is_array($overview)) {
				reset($overview);
				$this->overview = $overview;
				return TRUE;
			}
			else {$this->overview = array(); return FALSE; }
		}
	}
	
	//forward an email to a list of recievers.
	//the additional header information is what took me some
	//hours of boring work because I have to extract this
	//information from the old header and compose it to a
	//new header in an exact way. Better don't make any
	//changes here.
	function forward_mail($msgNo,$email_list)
	{
		if (!$this->connected) $this->connect();
		if ($this->connected)
		$this->header = imap_fetchheader($this->mbox,$msgNo);
		$this->body = imap_body($this->mbox,$msgNo);
		$header_addon = "From: <" . $this->from . ">\n";
		$header_addon .= find_extractline("MIME-VERSION",$this->header) . "\n";
		$header_addon .= find_extractline("CONTENT-TYPE",$this->header);
		$header_addon .= "\t" . find_extractline("BOUNDARY",$this->header);
		$subject = substr(find_extractline("SUBJECT",$this->header),9);
		$counter = 0;
		for ($i=0; $i<=count($email_list); $i++)
		{
			if (mail($email_list[$i],$subject,$this->body,$header_addon)) $counter++;
		}
		return $counter;
	}
	
	//delete mail from mailbox. for example after you send it
	function delete_mail($msgNo)
	{
		if (!$this->connected) $this->connect();
		if ($this->connected)
		imap_delete($this->mbox,$msgNo);
		imap_expunge($this->mbox);
	}
}